package musr.client.bestfit;
/*package musr.client.bestfit;
import musr.client.gui.*;
import javax.swing.*;
import musr.client.datacolumn.*;
import java.awt.event.*;
import musr.client.function.Function;
import java.awt.*;
import java.util.Date;
import java.util.StringTokenizer;

public class FitTester extends JFrame implements ActionListener, java.io.Serializable
{
    private DataColumn xValues;
    private DataColumn yValues;
    private BestFit fitter = null;
    private Function bestFit = null;
    private JTextArea outputArea;
    public GUI parent;
    private JSpinner degreeSetter;

    private static int WIDTH = 400;
    private static int HEIGHT = 247;
    private static int TEXT_AREA_ROWS = 3;
    private static int TEXT_AREA_COLUMNS = 23;
    
    public static void main(String[] args)
    {
        FitTester test = new FitTester();
        test.setVisible(true);
    }
    
    public FitTester()
    {      
        ConcreteDataColumn x = new ConcreteDataColumn("TEST", "test", "", new Date());
        ConcreteDataColumn plusXErrors = new ConcreteDataColumn("xPLUS", "pluserror", "", new Date());
        ConcreteDataColumn minusXErrors = new ConcreteDataColumn("xMinus", "minuserror", "", new Date());
       
        ConcreteDataColumn y = new ConcreteDataColumn("Y", "yvalues", "", new Date());
        ConcreteDataColumn plusYErrors = new ConcreteDataColumn("yPLUS", "pluserror", "", new Date());
        ConcreteDataColumn minusYErrors = new ConcreteDataColumn("yMINUS", "minuserror", "", new Date());
        
        for(int i=1; i<=10; i++)
        {
            x.addElement(new Double(i));
            plusXErrors.addElement(new Double(fPlus(i)));
            minusXErrors.addElement(new Double(fMinus(i)));
            y.addElement(new Double(f(i)));
            plusYErrors.addElement(new Double(fPlus(i)));
            minusYErrors.addElement(new Double(fMinus(i)));
        }
            
        xValues = new MultiColumn(x, plusXErrors, minusXErrors);
        yValues = new MultiColumn(y, plusYErrors, minusYErrors);
        
        this.setTitle("Best Fit");
        this.setSize(WIDTH, HEIGHT);
        this.addWindowListener(new WindowDestroyer(this));
        
        Container contentPane = this.getContentPane();
        contentPane.setLayout(new BorderLayout());
        contentPane.setBackground(Color.BLACK);
        
        JPanel specsPanel = new JPanel();
        specsPanel.setLayout(new GridLayout(5,1));

        specsPanel.add(new JLabel("Order of fit:"));
        
        degreeSetter = new JSpinner(new SpinnerNumberModel(2, 1, 6, 1));
        //degreeSetter.setSize(degreeSetter.getWidth()/2, degreeSetter.getHeight());
        specsPanel.add(degreeSetter);
        
        specsPanel.add(new JSeparator());     //Blank space!
        
        JButton findFit = new JButton("Find Fit");
        findFit.addActionListener(this);
        specsPanel.add(findFit);
        
        JButton reset = new JButton("Reset");
        reset.addActionListener(this);
        specsPanel.add(reset);
        
        contentPane.add(specsPanel, BorderLayout.EAST);
        
        JPanel outputPanel = new JPanel();
        outputPanel.setLayout(new BorderLayout());
        
        outputPanel.add(new JLabel("Best fit for \n" + yValues.getName() + " vs. " + xValues.getName() + ":"), BorderLayout.NORTH);
        
        outputArea = new JTextArea(TEXT_AREA_ROWS, TEXT_AREA_COLUMNS);
        outputArea.setText("To find the best-fit equation, select the order\nof the fit equation, then click \"Find Fit\"." +
                "\nFor high-order polynomials or very long columns,\nroundoff error will accumulate.");
        outputPanel.add(new JScrollPane(outputArea), BorderLayout.CENTER);
        
        contentPane.add(outputPanel, BorderLayout.CENTER);
        
        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new FlowLayout());
        
        JButton newCol = new JButton("Add to Columns");
        newCol.addActionListener(this);
        buttonPanel.add(newCol);
        
        JButton newFunc = new JButton("Add to Functions");
        newFunc.addActionListener(this);
        buttonPanel.add(newFunc);
        
        JButton close = new JButton("Close");
        close.addActionListener(this);
        buttonPanel.add(close);
        
        contentPane.add(buttonPanel, BorderLayout.SOUTH);
    }
    
    public void actionPerformed(ActionEvent e)
    {
        String command = e.getActionCommand();
        
        if(command.equals("Close"))
            this.dispose();
        
        else if(command.equals("Add to Columns"))
        {
            if(fitter!=null)
            {
                ConcreteDataColumn values = new ConcreteDataColumn(
                        "fit", "Best fit for " + getName(), "", new Date());
                ConcreteDataColumn plusError = new ConcreteDataColumn();
                ConcreteDataColumn minusError = new ConcreteDataColumn();
                for(int i=0; i<xValues.getSize(); i++)
                {
                    values.addElement(new Double(fitter.evaluateAt(((Double)xValues.getValue(i)).doubleValue())));
                    plusError.addElement(new Double(fitter.evaluateAt(((Double)xValues.getErrorPlus(i)).doubleValue())));
                    minusError.addElement(new Double(fitter.evaluateAt(((Double)xValues.getErrorMinus(i)).doubleValue())));
                }
                MultiColumn result = new MultiColumn(values, plusError, minusError);
                System.out.println("Best fit for " + getName() + " added as a column.");
            }
            else
                JOptionPane.showMessageDialog(null, "No best fit has been found yet! Click \"Find Fit\" to find the curve of best fit.");
        }
        
        else if(command.equals("Add to Functions"))
        {
            if(fitter!=null)
                System.out.println(("Best fit for " + getName()) + ": "  + fitter.toString());
            else
                JOptionPane.showMessageDialog(null, "No best fit has been found yet! Click \"Find Fit\" to find the curve of best fit.");
        }
            
        else if(command.equals("Find Fit"))
            findFit();
        
        else if(command.equals("Reset"))
            outputArea.setText("To find the best-fit equation, select the order\nof the fit equation, then click \"Find Fit\"." +
                "\nFor high-order polynomials or very long columns,\nroundoff error will accumulate.");
        
        else
            System.out.println("Error in user interface.");
    }
    
    public String getName()
    {
        return xValues.getName();
    }
    
    
    private class WindowDestroyer extends WindowAdapter
    {
        private JFrame gui;
        
        public WindowDestroyer(JFrame newGUI)
        {
            super();
            gui = newGUI;
        }
        
        public void windowClosing(WindowEvent e)
        {
            gui.dispose();
        }
    }
    
    public String toString()
    {
        String result = "y= " + fitter.toString();
        for(int i=1; i<result.length()/TEXT_AREA_COLUMNS; i++)
        {
            int index = TEXT_AREA_COLUMNS*i;
            while((result.charAt(index)!='+')&&(result.charAt(index)!='-'))
                index++;
            result = result.substring(0, index+1) + "    \n" + result.substring(index+1);
        }
        return result;
    }
    
    private void findFit()
    {
        fitter = new BestFit(xValues, yValues, ((Integer)degreeSetter.getValue()).intValue());
        bestFit = fitter.findBestFit();
        String result = "y = " + fitter.toString();
        //Format result to put it on lines:
        StringTokenizer tokenizer = new StringTokenizer(result);
        int currentPosition=0;
        String currentToken;
        while(tokenizer.hasMoreTokens())
        {
            currentToken = tokenizer.nextToken();
            currentPosition = currentPosition + currentToken.length() +1 ;
            if(((currentToken.equals("+"))||(currentToken.equals("-")))&&(currentPosition%20>2))
                result = result.substring(0, currentPosition) + "\n" + result.substring(currentPosition);
        }
        outputArea.setText(result);
    }
    
    private double f(double i)
    {
        return /*i*i*i*i*i*i-2*i*i*i*i*i+3*i*i*i*i-4*i*i*i+5*i*i-6*i+7;
    }
    
    private double fMinus(double i)
    {
        return i/100;
    }
    
    private double fPlus(double i)
    {
        return i/100;
    }
}*/