package musr.client.dbchecker;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class DBDiagnosticGUI extends JFrame implements ActionListener
{
    public static final int WIDTH = 575;
    public static final int HEIGHT = 300;
    private File dbFile;
    private JTextArea textArea;
    public static final int LINES = 15;
    public static final int CHARACTERS_PER_LINE = 40;
    
    public DBDiagnosticGUI(File newDB)
    {
        this.dbFile = newDB;
        this.setSize(WIDTH, HEIGHT);
        //this.addWindowListener(new WindowDestroyer());
        this.setTitle("DBDiagnostic");
        
        Container contentPane = this.getContentPane();
        contentPane.setLayout(new BorderLayout());
        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new FlowLayout());
        
        JButton close = new JButton("Close");
        close.setToolTipText("Close the DB checker window.");
        close.addActionListener(this);
        JButton diagnose = new JButton("Diagnose");
        diagnose.setToolTipText("Check for errors in the selected .db file.");
        diagnose.addActionListener(this);
        
        buttonPanel.add(diagnose);
        buttonPanel.add(close);
        contentPane.add(buttonPanel, BorderLayout.SOUTH);
        
        JPanel textPanel = new JPanel();
        textPanel.setBackground(Color.LIGHT_GRAY);
        textArea = new JTextArea(LINES, CHARACTERS_PER_LINE);
        textArea.setBackground(Color.LIGHT_GRAY);
        
        textArea.setText(this.dbFile.getName());
        textPanel.add(textArea);
        contentPane.add(textPanel, BorderLayout.CENTER);
    }
    
    public void actionPerformed(ActionEvent e)
    {
        String command = e.getActionCommand();
        if(command.equals("Close"))
            this.dispose();
        else if(command.equals("Diagnose"))
        {
            DBDiagnostic checker = new DBDiagnostic(dbFile);
            checker.diagnose();
            textArea.setText(checker.toString());
        }
    }
}