package musr.client.dbreader;

import java.awt.*;
import java.lang.*;
import java.util.*;
import musr.client.plot2d.Tools;
import musr.client.gui.*;
import musr.client.function.*;
import javax.swing.*;

/**
 * Holds values for various constants with
 *
 * @author Ivan Tucakov
 */
public class Constants implements Cloneable, java.io.Serializable {

  static final long serialVersionUID = 0L; // SUID

  // No Constructor

  /* Constants */

  public  Vector CONSTANT = new Vector();
  public  Vector CONSTANT_VALUE = new Vector();
  public  Vector CONSTANT_DESCRIPTION = new Vector();

  public Constants() {
    // Create all the default constants
    CONSTANT.addElement("!-----");
    CONSTANT_VALUE.addElement("0"); // put zero because the the value needs to be evalueted as an expression
    CONSTANT_DESCRIPTION.addElement("  MATHEMATICAL CONSTANTS:");
    CONSTANT.addElement("pi");
    CONSTANT_VALUE.addElement("3.141592653589793238462");
    CONSTANT_DESCRIPTION.addElement("  ! Pi to an incredible accuracy");
    CONSTANT.addElement("twoPi");
    CONSTANT_VALUE.addElement("2*pi");
    CONSTANT_DESCRIPTION.addElement("  ");

    CONSTANT.addElement("!-----");
    CONSTANT_VALUE.addElement("0");
    CONSTANT_DESCRIPTION.addElement("  FUNDAMENTAL PHYSICAL CONSTANTS [SI units]:");
    CONSTANT.addElement("c");
    CONSTANT_VALUE.addElement("2.99792458E+08");
    CONSTANT_DESCRIPTION.addElement("  ! Speed of light [m/s]");
    CONSTANT.addElement("e");
    CONSTANT_VALUE.addElement("1.60217653E-19");
    CONSTANT_DESCRIPTION.addElement("  ! Elementary charge [Coulombs]");
    CONSTANT.addElement("Planck");
    CONSTANT_VALUE.addElement("6.6260693E-34");
    CONSTANT_DESCRIPTION.addElement("  ! Planck's constant [J-s]");
    CONSTANT.addElement("h");
    CONSTANT_VALUE.addElement("Planck");
    CONSTANT_DESCRIPTION.addElement("  ");
    CONSTANT.addElement("hbar");
    CONSTANT_VALUE.addElement("1.05457168e-34");
    CONSTANT_DESCRIPTION.addElement("  ! Planck's constant / 2*Pi [J-s]");

    CONSTANT.addElement("!-----");
    CONSTANT_VALUE.addElement("0");
    CONSTANT_DESCRIPTION.addElement("  UNIT CONVERSION FACTORS:");
    CONSTANT.addElement("day");
    CONSTANT_VALUE.addElement("24*60*60");
    CONSTANT_DESCRIPTION.addElement("  ! Seconds in a Day");
    CONSTANT.addElement("year");
    CONSTANT_VALUE.addElement("365*day");
    CONSTANT_DESCRIPTION.addElement("  ! Seconds in a Year");
    CONSTANT.addElement("mi");
    CONSTANT_VALUE.addElement("1609.344");
    CONSTANT_DESCRIPTION.addElement("  ! One mile [m]");
    CONSTANT.addElement("eV");
    CONSTANT_VALUE.addElement("e");
    CONSTANT_DESCRIPTION.addElement("  ! 1 electron volt [J]");
    CONSTANT.addElement("MeV");
    CONSTANT_VALUE.addElement("1e6*eV");
    CONSTANT_DESCRIPTION.addElement("  ! Joules per MeV");
    CONSTANT.addElement("J_kg");
    CONSTANT_VALUE.addElement("c*c");
    CONSTANT_DESCRIPTION.addElement("  ! Joules per kilogram (E=mc^2)");
    CONSTANT.addElement("kg_MeV");
    CONSTANT_VALUE.addElement("MeV/J_kg");
    CONSTANT_DESCRIPTION.addElement("  ! kilograms per MeV/c^2");
    CONSTANT.addElement("MeV_kg");
    CONSTANT_VALUE.addElement("1/kg_MeV");
    CONSTANT_DESCRIPTION.addElement("  ! MeV/c^2 per kilogram");

    CONSTANT.addElement("!-----");
    CONSTANT_VALUE.addElement("0");
    CONSTANT_DESCRIPTION.addElement("  Fundamental Constants in Special Units:");
    CONSTANT.addElement("hbar_MeV");
    CONSTANT_VALUE.addElement("hbar/MeV");
    CONSTANT_DESCRIPTION.addElement("  ! Planck's constant / 2*Pi [MeV-s]");
    CONSTANT.addElement("h_MeV");
    CONSTANT_VALUE.addElement("hbar_MeV*twoPi");
    CONSTANT_DESCRIPTION.addElement("  ! Planck's constant [MeV-s]");

    CONSTANT.addElement("!-----");
    CONSTANT_VALUE.addElement("0");
    CONSTANT_DESCRIPTION.addElement("  Selected PARTICLE PROPERTIES [SI units]:");
    CONSTANT.addElement("Mel");
    CONSTANT_VALUE.addElement("0.91093826e-30");
    CONSTANT_DESCRIPTION.addElement("  ! Electron mass [kg]");
    CONSTANT.addElement("Mel_MeV");
    CONSTANT_VALUE.addElement("0.510998918");
    CONSTANT_DESCRIPTION.addElement("  ! Electron mass [MeV/c^2]");
    CONSTANT.addElement("Mmu_MeV");
    CONSTANT_VALUE.addElement("105.658389");
    CONSTANT_DESCRIPTION.addElement("  ! Muon Mass [MeV/c^2]");
    CONSTANT.addElement("Mmu");
    CONSTANT_VALUE.addElement("Mmu_MeV*kg_MeV");
    CONSTANT_DESCRIPTION.addElement("  ! Muon Mass [kg]");
    CONSTANT.addElement("zeta");
    CONSTANT_VALUE.addElement("Mel/Mmu");
    CONSTANT_DESCRIPTION.addElement("  ! electron to muon mass ratio");
    CONSTANT.addElement("Mp");
    CONSTANT_VALUE.addElement("1.67262171e-27");
    CONSTANT_DESCRIPTION.addElement("  ! Proton mass [kg]");
    CONSTANT.addElement("Mp_MeV");
    CONSTANT_VALUE.addElement("938.272029");
    CONSTANT_DESCRIPTION.addElement("  ! Proton mass [MeV/c^2]");
    CONSTANT.addElement("Mn_MeV");
    CONSTANT_VALUE.addElement("939.56563");
    CONSTANT_DESCRIPTION.addElement("  ! Neutron mass [MeV/c^2]");
    CONSTANT.addElement("Mn");
    CONSTANT_VALUE.addElement("Mn_MeV*kg_MeV");
    CONSTANT_DESCRIPTION.addElement("  ! Neutron mass [kg]");
    CONSTANT.addElement("AMU");
    CONSTANT_VALUE.addElement("1.66053886e-27");
    CONSTANT_DESCRIPTION.addElement("  ! Atomic Mass Unit [kg]");
    CONSTANT.addElement("AMU_MeV");
    CONSTANT_VALUE.addElement("931.494043");
    CONSTANT_DESCRIPTION.addElement("  ! 1/12 mass of carbon-12 [MeV/c^2]");
    CONSTANT.addElement("Mpi_MeV");
    CONSTANT_VALUE.addElement("139.5669");
    CONSTANT_DESCRIPTION.addElement("  ! Charged Pion mass [MeV/c^2]");
    CONSTANT.addElement("Mpi_MeV");
    CONSTANT_VALUE.addElement("139.5669");
    CONSTANT_DESCRIPTION.addElement("  ! Charged Pion mass [MeV/c^2]");
    CONSTANT.addElement("Mpi");
    CONSTANT_VALUE.addElement("Mpi_MeV*kg_MeV");
    CONSTANT_DESCRIPTION.addElement("  ! Charged Pion mass [kg]");
    CONSTANT.addElement("Mpi0_MeV");
    CONSTANT_VALUE.addElement("134.9626");
    CONSTANT_DESCRIPTION.addElement("  ! Neutral Pion mass [MeV/c^2]");
    CONSTANT.addElement("Mpi0");
    CONSTANT_VALUE.addElement("Mpi0_MeV*kg_MeV");
    CONSTANT_DESCRIPTION.addElement("  ! Neutral Pion mass [kg]");
    CONSTANT.addElement("Pmu");
    CONSTANT_VALUE.addElement("(MPi*MPi-Mmu*Mmu)/(2*MPi)");
    CONSTANT_DESCRIPTION.addElement("  ! Surface Muon Momentum [MeV/c]");
    CONSTANT.addElement("KEmu");
    CONSTANT_VALUE.addElement("sqrt(Pmu*Pmu+Mmu*Mmu)-Mmu");
    CONSTANT_DESCRIPTION.addElement("  ! Surface Muon K.E. [MeV]");
    CONSTANT.addElement("tauMu");
    CONSTANT_VALUE.addElement("2.19703e-6");
    CONSTANT_DESCRIPTION.addElement("  ! Muon mean life (seconds)");
    CONSTANT.addElement("tauPi");
    CONSTANT_VALUE.addElement("26.030e-9");
    CONSTANT_DESCRIPTION.addElement("  ! Charged Pion mean life (seconds)");
    CONSTANT.addElement("tauPi0");
    CONSTANT_VALUE.addElement("0.828e-16");
    CONSTANT_DESCRIPTION.addElement("  ! Neutral Pion mean life (seconds)");
    CONSTANT.addElement("tauN");
    CONSTANT_VALUE.addElement("917");
    CONSTANT_DESCRIPTION.addElement("  ! Neutron mean life (seconds)");

    CONSTANT.addElement("!-----");
    CONSTANT_VALUE.addElement("0");
    CONSTANT_DESCRIPTION.addElement("  ELECTROMAGNETIC CONSTANTS [SI units]:");
    CONSTANT.addElement("eps0");
    CONSTANT_VALUE.addElement("1e7/(4*pi*c*c)");
    CONSTANT_DESCRIPTION.addElement("  ! Permittivity of free space [SI units]");
    CONSTANT.addElement("mu0");
    CONSTANT_VALUE.addElement("4*pi*1e-7");
    CONSTANT_DESCRIPTION.addElement("  ! Susceptibility of free space [SI units]");
    CONSTANT.addElement("kE");
    CONSTANT_VALUE.addElement("1/(4*pi*eps0)");
    CONSTANT_DESCRIPTION.addElement("  ! constant in Coulomb's Law [SI units]");

    CONSTANT.addElement("!-----");
    CONSTANT_VALUE.addElement("0");
    CONSTANT_DESCRIPTION.addElement("  ATOMIC CONSTANTS [SI units]:");
    CONSTANT.addElement("alpha");
    CONSTANT_VALUE.addElement("1/137.03599911");
    CONSTANT_DESCRIPTION.addElement("  ! Fine structure constant");
    CONSTANT.addElement("muB_MeV_T");
    CONSTANT_VALUE.addElement("5.788381804e-11");
    CONSTANT_DESCRIPTION.addElement("  ! Bohr Magneton [MeV/T]");
    CONSTANT.addElement("mu_Bohr");
    CONSTANT_VALUE.addElement("muB_MeV_T*MeV");
    CONSTANT_DESCRIPTION.addElement("  ! Bohr Magneton [J/T]");
    CONSTANT.addElement("muB");
    CONSTANT_VALUE.addElement("e*hbar/(2*Mel)");
    CONSTANT_DESCRIPTION.addElement("  ! Bohr Magneton [J/T]");
    CONSTANT.addElement("a0");
    CONSTANT_VALUE.addElement("(hbar/(e*e*kE))*(hbar/Mel)");
    CONSTANT_DESCRIPTION.addElement("  ! Bohr radius [m]");
    CONSTANT.addElement("rBohr");
    CONSTANT_VALUE.addElement("a0");
    CONSTANT_DESCRIPTION.addElement("  ! Bohr radius [m]");
    CONSTANT.addElement("rEl");
    CONSTANT_VALUE.addElement("2.817940325e-15");
    CONSTANT_DESCRIPTION.addElement("  ! Classical radius of the electron [m]");
    CONSTANT.addElement("lCompt");
    CONSTANT_VALUE.addElement("twoPi*rEl/alpha");
    CONSTANT_DESCRIPTION.addElement("  ! Compton wavelenth of the electron [m]");
    CONSTANT.addElement("Rydberg");
    CONSTANT_VALUE.addElement("Mel*c*c*alpha*alpha/2");
    CONSTANT_DESCRIPTION.addElement("  ! Rydberg energy [J]");
    CONSTANT.addElement("Rydb_eV");
    CONSTANT_VALUE.addElement("Rydberg/eV");
    CONSTANT_DESCRIPTION.addElement("  ! Rydberg energy [eV]");
    CONSTANT.addElement("muN_MeV_T");
    CONSTANT_VALUE.addElement("3.152451259e-14");
    CONSTANT_DESCRIPTION.addElement("  ! Nuclear Magneton [MeV/T]");
    CONSTANT.addElement("muN");
    CONSTANT_VALUE.addElement("muN_MeV_T*MeV");
    CONSTANT_DESCRIPTION.addElement("  ! Nuclear Magneton [J/T]");
    CONSTANT.addElement("eAnom");
    CONSTANT_VALUE.addElement("0.001159652193");
    CONSTANT_DESCRIPTION.addElement("  ! fractional Anomalous Moment of electron");
    CONSTANT.addElement("mu_e");
    CONSTANT_VALUE.addElement("(1+eAnom)*muB");
    CONSTANT_DESCRIPTION.addElement("  ! Electron Magnetic Moment [J/T]");
    CONSTANT.addElement("muAnom");
    CONSTANT_VALUE.addElement("0.001165923");
    CONSTANT_DESCRIPTION.addElement("  ! fractional Anomalous Moment of muon");
    CONSTANT.addElement("mu_mu");
    CONSTANT_VALUE.addElement("(1+muAnom)*zeta*muB");
    CONSTANT_DESCRIPTION.addElement("  ! Muon Magnetic Moment [J/T]");
    CONSTANT.addElement("mu_p");
    CONSTANT_VALUE.addElement("2.79284739*muN");
    CONSTANT_DESCRIPTION.addElement("  ! Proton Magnetic Moment [J/T]");

    CONSTANT.addElement("!-----");
    CONSTANT_VALUE.addElement("0");
    CONSTANT_DESCRIPTION.addElement("  ASTRONOMICAL CONSTANTS [SI units]:");
    CONSTANT.addElement("GG");
    CONSTANT_VALUE.addElement("6.6742e-11");
    CONSTANT_DESCRIPTION.addElement("  ! Univ. Grav. const. [m^3/kg*s^2]");
    CONSTANT.addElement("g");
    CONSTANT_VALUE.addElement("9.80665");
    CONSTANT_DESCRIPTION.addElement("  ! mean Accel. of grav. @ Earth's surface [m/s^2]");
    CONSTANT.addElement("mEarth");
    CONSTANT_VALUE.addElement("5.9742e24");
    CONSTANT_DESCRIPTION.addElement("  ! Earth's mass [kg]");
    CONSTANT.addElement("rEarth");
    CONSTANT_VALUE.addElement("6.378164e6");
    CONSTANT_DESCRIPTION.addElement("  ! Earth's mean radius [m]");
    CONSTANT.addElement("RE");
    CONSTANT_VALUE.addElement("rEarth");
    CONSTANT_DESCRIPTION.addElement("  ");
    CONSTANT.addElement("mMoon");
    CONSTANT_VALUE.addElement("0.0123*mEarth");
    CONSTANT_DESCRIPTION.addElement("  ! Moon's mass [kg]");
    CONSTANT.addElement("rMoon");
    CONSTANT_VALUE.addElement("3.476e6");
    CONSTANT_DESCRIPTION.addElement("  ! Moon's mean radius [m]");
    CONSTANT.addElement("rEM");
    CONSTANT_VALUE.addElement("3.84399e8");
    CONSTANT_DESCRIPTION.addElement("  ! Earth-Moon mean radius [m]");
    CONSTANT.addElement("rSun");
    CONSTANT_VALUE.addElement("6.9599e8");
    CONSTANT_DESCRIPTION.addElement("  ! Solar radius [m]");
    CONSTANT.addElement("vSun");
    CONSTANT_VALUE.addElement("1.97e4");
    CONSTANT_DESCRIPTION.addElement("  ! Solar velocity wrt. Galaxy [m/s]");
    CONSTANT.addElement("mSun");
    CONSTANT_VALUE.addElement("1.989e30");
    CONSTANT_DESCRIPTION.addElement("  ! Solar mass [kg]");
    CONSTANT.addElement("tSun");
    CONSTANT_VALUE.addElement("5800");
    CONSTANT_DESCRIPTION.addElement("  ! Sun's effective temperature [K]");
    CONSTANT.addElement("LumSun");
    CONSTANT_VALUE.addElement("3.826e26");
    CONSTANT_DESCRIPTION.addElement("  ! Solar luminosity [J/s]");
    CONSTANT.addElement("SolConst");
    CONSTANT_VALUE.addElement("1.353e3");
    CONSTANT_DESCRIPTION.addElement("  ! Solar constant at Earth [W/m^2]");
    CONSTANT.addElement("rSE");
    CONSTANT_VALUE.addElement("1.4959787e11");
    CONSTANT_DESCRIPTION.addElement("  ! Sun-Earth mean radius [m]");
    CONSTANT.addElement("AU");
    CONSTANT_VALUE.addElement("rSE");
    CONSTANT_DESCRIPTION.addElement("  ! one Astronomical unit [m] (=rSE)");
    CONSTANT.addElement("LY");
    CONSTANT_VALUE.addElement("9.46053e15");
    CONSTANT_DESCRIPTION.addElement("  ! one light year [m]");
    CONSTANT.addElement("PSC");
    CONSTANT_VALUE.addElement("3.085678e16");
    CONSTANT_DESCRIPTION.addElement("  ! one parsec [m]");
    CONSTANT.addElement("EccEarth");
    CONSTANT_VALUE.addElement("0.017");
    CONSTANT_DESCRIPTION.addElement("  ! Eccentricity of Earth's orbit");

    CONSTANT.addElement("!-----");
    CONSTANT_VALUE.addElement("0");
    CONSTANT_DESCRIPTION.addElement("  THERMAL PHYSICS CONSTANTS [mostly SI units]:");
    CONSTANT.addElement("N0");
    CONSTANT_VALUE.addElement("6.0221415e23");
    CONSTANT_DESCRIPTION.addElement("  ! Avogadro's number / Mole.");
    CONSTANT.addElement("kB");
    CONSTANT_VALUE.addElement("1.3806505e-23");
    CONSTANT_DESCRIPTION.addElement("  ! Boltzmann's const [J/K]");
    CONSTANT.addElement("kB_eV");
    CONSTANT_VALUE.addElement("8.617343e-5");
    CONSTANT_DESCRIPTION.addElement("  ! Boltzmann's const in eV/K");
    CONSTANT.addElement("kSB");
    CONSTANT_VALUE.addElement("(pi*pi/60)*((kB/(hbar*c))^3)*kB*c");
    CONSTANT_DESCRIPTION.addElement("  ! Stefan-Boltzmann constant [W/m^2/K^4]");

    CONSTANT.addElement("!-----");
    CONSTANT_VALUE.addElement("0");
    CONSTANT_DESCRIPTION.addElement("  muSR Constants [mixed units]:");
    CONSTANT.addElement("GMU_T");
    CONSTANT_VALUE.addElement("2e-6*mu_mu/h");
    CONSTANT_DESCRIPTION.addElement("  ! Muon magnetogyric ratio [MHz/T]");
    CONSTANT.addElement("GMU");
    CONSTANT_VALUE.addElement("GMU_T*1e-4");
    CONSTANT_DESCRIPTION.addElement("  ! Muon magnetogyric ratio [MHz/G]");
    CONSTANT.addElement("GMU_exp");
    CONSTANT_VALUE.addElement("0.013553879");
    CONSTANT_DESCRIPTION.addElement("  ! Alex Schenck's experimental value [MHz/G]");
    CONSTANT.addElement("GE_T");
    CONSTANT_VALUE.addElement("2e-6*mu_e/h");
    CONSTANT_DESCRIPTION.addElement("  ! Electron magnetogyric ratio [MHz/T]");
    CONSTANT.addElement("GE");
    CONSTANT_VALUE.addElement("GE_T*1e-4");
    CONSTANT_DESCRIPTION.addElement("  ! Electron magnetogyric ratio [MHz/G]");
    CONSTANT.addElement("GMM");
    CONSTANT_VALUE.addElement("0.5*(GE-GMU)");
    CONSTANT_DESCRIPTION.addElement("  ! Muonium  magnetogyric ratio [MHz/G]");
    CONSTANT.addElement("GPL");
    CONSTANT_VALUE.addElement("GMM+GMU");
    CONSTANT_DESCRIPTION.addElement("  ");
    CONSTANT.addElement("GMN");
    CONSTANT_VALUE.addElement("GMM-GMU");
    CONSTANT_DESCRIPTION.addElement("  ");
    CONSTANT.addElement("GP");
    CONSTANT_VALUE.addElement("2e-6*mu_p/h");
    CONSTANT_DESCRIPTION.addElement("  ! Proton magnetogyric ratio [MHz/G]");
    CONSTANT.addElement("HFMu");
    CONSTANT_VALUE.addElement("4463.302");
    CONSTANT_DESCRIPTION.addElement("  ! Muonium HF frequency in vacuum [MHz]");
    CONSTANT.addElement("BHF");
    CONSTANT_VALUE.addElement("HFMu/(2*GPL)");
    CONSTANT_DESCRIPTION.addElement("  ! Muonium Hyperfine Field in vacuum [G]");
    CONSTANT.addElement("FLUXQ");
    CONSTANT_VALUE.addElement("2.06783461E-7");
    CONSTANT_DESCRIPTION.addElement("  ! Flux Quantum = hc/2e  [erg-s/emu or G-cm2]");
    CONSTANT.addElement("dt0BNC");
    CONSTANT_VALUE.addElement("48.848125E-3");
    CONSTANT_DESCRIPTION.addElement("  ! Min bin size [ns] in BNC Clock");

    CONSTANT.addElement("!-----");
    CONSTANT_VALUE.addElement("0");
    CONSTANT_DESCRIPTION.addElement("  muView Constants:");

  }

  /**
   * Sets the two values for the new constant, the name and the value
   */
  public void setConstant(String name, String value, String description) {
    int index = CONSTANT.indexOf(name);
    if (index == -1) { // if this variable hasn't already been defined, put it in
      CONSTANT.addElement(name);
      CONSTANT_VALUE.addElement(value);
      CONSTANT_DESCRIPTION.addElement(description);
    } else { // if it exists, replace it's value
      CONSTANT.set(index, name);
      CONSTANT_VALUE.set(index, value);
      CONSTANT_DESCRIPTION.addElement(description);
    }
  }
  /**
   * This is used to check whether the variable exists
   */
  public boolean constantExists(Frame parent, String name) {
    boolean result = false;
    for (int i=0; i<CONSTANT.size(); i++) {
      if (!((GUI)parent).caseMenuItem.getState()) {
        if (name.toUpperCase().equals(new String( (String)CONSTANT.get(i)).toUpperCase())) result=true;
      } else {
        if (name.equals(new String( (String)CONSTANT.get(i)))) result=true;
      }
    }
    return result;
  }
  /** Finds the new constant value and returns it. If not found, it returns -1.*/
  public double getConstantValue(Frame parent, String name) {
      //define a vector with all constant names in lowercase
      Vector constantLowercase = new Vector(CONSTANT);
      for(int i=0; i<constantLowercase.size(); i++)
      {
          constantLowercase.setElementAt(((String)(constantLowercase.get(i))).toLowerCase(),i);
      }
    int index = constantLowercase.indexOf(name.toLowerCase());
    if (index!=-1) {
      return evaluateConstant(parent, (String)CONSTANT_VALUE.get(index));
      //Function fun = new Function((String)CONSTANT_VALUE.get(index));
      // return fun.evaluate(((GUI)parent), -1, ((GUI)parent).caseMenuItem.getState(), ((GUI)parent).functionsTable, ((GUI)parent).dataTableVariables); //-1 is a dummy variable, since the expression doesn't contain x
    } else 
    {
        System.out.println("The following constant was not found:\n" + name);
        return -1;
    }
  }
  /** Finds the new constant value and returns it. If not found, it returns -1.*/
  public double getConstantValue(Frame parent, int index) {
    if (index!=-1) {
      return evaluateConstant(parent, (String)CONSTANT_VALUE.get(index));
    } else return -1;
//System.out.println("(String)CONSTANT_VALUE.get(index): "+(String)CONSTANT_VALUE.get(index));
  }
  /** Returns the size of the CONSTANT vector*/
   public int getSize() {
     return CONSTANT.size();
   }
  /** Returns the index of the first occurence of the object in the CONSTANT vector, if not there, return -1 */
  public int indexOf(Frame parent, String name) {
    int index = -1;
//System.out.println(" ((GUI)parent).caseMenuItem.getState(): "+((GUI)parent).caseMenuItem.getState());
    for (int i=0; i<CONSTANT.size(); i++) {
      if ( !((GUI)parent).caseMenuItem.getState() ) {
//System.out.println(" CONSTANT.get(i).toString().toUpperCase(): "+CONSTANT.get(i).toString().toUpperCase());
        if ( CONSTANT.get(i).toString().toUpperCase().equals( name.toUpperCase() )  )
          index = i;
      } else {
        if ( CONSTANT.get(i).toString().equals( name )  )
          index = i;
      }
    }
  return index;
  }
  /** Returns the element at the given index in the CONSTANT vector*/
   public Object getConstantName(int index) {return CONSTANT.get(index);}

   public Object clone () throws CloneNotSupportedException {
      Constants returnValue = (Constants)super.clone();
      returnValue.CONSTANT = (Vector)CONSTANT.clone();
      //note: don't need to clone the Strings within the vetor.
      returnValue.CONSTANT_VALUE = (Vector)CONSTANT_VALUE.clone();
      return returnValue;
  }

           public double evaluateConstant(Frame parent, String expr) {
//System.out.println("expr sent to evaluateExpr: "+expr);
          String param = ""; // this is the parameter(s) we are loking for
          StringTokenizer tokenizer; // parse the line
          String newExpr = expr; // this will be the final expression with no parameters in it
          // Note: the delimiters are set to true, so that it would be possible to get '(' and check for function calls
          tokenizer = new StringTokenizer(newExpr, "()+-*/^ ", true);
          // In order to avoid the bug of having a number that contains exponential letter E within it put into
          // the string and then having to search for a constant or column named E, use this number (strPointer) so that I
          // wouldn't have to traverse through the string from the start, therefore I wouldn't exchange the wrong letter
          int strPointer = -1;

          // When the 'paramNo'-th column value parameter has been reached, add errorVal to it.
          // Use this parameter to keep track and know when to add the error value if needed (when paramNo!=-1).
          int countParam = 1;
          while (tokenizer.hasMoreTokens()) {
            String tempString = tokenizer.nextToken();
            char tempChar = tempString.charAt(0);
            if (Character.isLetter(tempChar)) { // if it is an expression (not a number or an arithmetic sign)
              // this means that we found some parameter. Find it and evaluate
              tempString = tempString.trim();
              String findValue = ""; // this value could be any non-numeric token, including sqrt,sqr..
              int columnIndex = ((GUI)parent).indexOfDataColumnNames(parent, tempString) ;
              // First check for function calls, in case someone named a variable same as some of the functions
              // This is done by looking up the next token, if it is '(' then it is a function call for sure
              // Note: calling nextToken will not affect the overall parsing of the expression!
              // make sure it is not the last element since there is a nextToken call and check if it is not a function
              //         Note: if the first condition if the if statement below is true, then the second one won't be evaluated,
              //                  that's really important since if hte tokenizer is at the end method nextToken can't be called
              if (!tokenizer.hasMoreTokens() || !tokenizer.nextToken().equals("(")) {
                // **** it must exist in the CONSTANTS table, since it is not a function, nor a column value ****
                // it also doesn't have error handling since it is just a constant
                if (columnIndex!=-1) { // a constant value was found
                  findValue=((Object)Tools.doubToObj(getConstantValue(parent, columnIndex))).toString();
                  param = tempString;
                  // now change the occurence of that parameter to the value of this parameter from the table
                  StringBuffer buff = new StringBuffer(newExpr);
                  // This will point to the index at the end of the token that is exchanged in the string
                  // +2 is for the brackets that are added, they are added in case the number has a + or - in front
                  int tmpStrPointer = newExpr.indexOf(param,strPointer)+findValue.length()+2;
                  // If caseOff is on, handle the expression parsing accordingly
                  int first, second = 0;
                  first = newExpr.indexOf(param,strPointer);
                  second = newExpr.indexOf(param,strPointer)+param.length();
                  buff.replace( first, second, "("+findValue+")" );
                  newExpr = buff.toString();
                  strPointer=tmpStrPointer;
//System.out.println("this is the newExpr for MOD (with constant parameter), strPointer: "+newExpr+", "+strPointer);
                }
              }
            }
          }
          // Create the function with this new expression (newExpr) and evaluate it
          newExpr = newExpr.trim();
          Function fun = new Function(newExpr);
          return fun.evaluate(parent, -1, ((GUI)parent).caseMenuItem.getState(), ((GUI)parent).functionsTable, ((GUI)parent).dataTableVariables); //-1 is a dummy variable, since the expression doesn't contain x
        }


}