package musr.client.dbreader;
import musr.client.datacolumn.*;
import musr.client.gui.*;
import musr.client.plot2d.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.security.*;
import java.util.Date;

/**
 *  This class exports the Data Tables from muView into db format
 *
 * @author Ivan Tucakov
 */
public class ExportDB {

       /**
        * This is the GUI where the console is called from
        */
       public Frame parent;
       public FileDialog d;
       public DataTable dataTable;

       public ExportDB(Frame paren) {
         this.parent = paren;
         d = new FileDialog(paren, "Save selected DataTable into '.db' file", FileDialog.SAVE);

        }
  //sdfsdh fshfjhsjg
        /**
         * This method is used to create and save the XML file on the hard drive
         */
        public void exportDB() {
                    String filename = "";
                    try {
                      d.setFile("DataTable.db");
                      d.setLocation(300,300);
                      d.show();  // display the dialog and block until answered
                      filename = d.getFile();   // Get the user's response
                      if ((filename != null) || (filename.length() != 0)) {           // If user didn't click "Cancel."
                          try {
                            // load the datatable if it exists
                            if ( (((GUI)parent).dataTableList.getSelectedIndex()!=-1) && (((GUI)parent).dataTableList.getItemCount() !=0) ) {

                              int dataTableKey = ((GUI)parent).getDataTableIndex();
                              dataTable = (DataTable) ((GUI)parent).dictionary.getElement(dataTableKey);

                              /*** This is where the file is written in *****/
                              // Use FileWriter and BufferedWriter to write the file
                              BufferedWriter outFile = new BufferedWriter( new FileWriter(d.getDirectory()+filename) );   // Create a stream to write

                                if (dataTable.getTitle()!=null) {
                                  outFile.write("TITLE"); outFile.newLine();
                                  outFile.write(dataTable.getTitle()); outFile.newLine();
                                }
                                if (dataTable.getAbstract()!=null) {
                                  outFile.write("ABSTRACT"); outFile.newLine();
                                  outFile.write(dataTable.getAbstract()); outFile.newLine();
                                }
                                outFile.newLine();

                                  // Show all the Labels
                                  outFile.write("LABELS"); outFile.newLine();
                                    // Traverse through all the columns
                                    for (int i=0; i<dataTable.columnCount(); i++) {
                                      outFile.write(dataTable.getColumn(i).getLabel()); outFile.newLine();
                                    }
                                  outFile.newLine();

                                  // Show all the Data Column Names
                                  outFile.write("DATA ");
                                    // Traverse through all the columns
                                    for (int i=0; i<dataTable.columnCount(); i++) {
                                      outFile.write(dataTable.getColumn(i).getName()+" ");
                                    }
                                  outFile.newLine();

                                    // Load Data
                                    for (int j=0; j<dataTable.getColumn(0).getSize(); j++) {
                                      // Traverse through all the columns and display their data
                                      for (int i=0; i<dataTable.columnCount(); i++) {
                                              String tempDataRow = new String( ((DataColumn)dataTable.getColumn(i)).getName()+
                                                                " = "+((DataColumn)dataTable.getColumn(i)).getValue(j)+"," );

                                              if ( Double.parseDouble( (String) ((DataColumn)dataTable.getColumn(i)).getErrorPlus(j).toString() )!=0)
                                                tempDataRow = tempDataRow.concat(((DataColumn)dataTable.getColumn(i)).getErrorPlus(j)+",");
                                              else
                                                tempDataRow = tempDataRow.concat(",");

                                              if ( Double.parseDouble( (String) ((DataColumn)dataTable.getColumn(i)).getErrorMinus(j).toString() )!=0)
                                                tempDataRow = tempDataRow.concat(((DataColumn)dataTable.getColumn(i)).getErrorMinus(j)+",");
                                              else
                                                tempDataRow = tempDataRow.concat(",");
                                              // The last line should not contain the forward slash since it is the end of a block of data
                                              if (i!=dataTable.columnCount()-1)
                                                tempDataRow = tempDataRow.concat(" \\");
                                              outFile.write(tempDataRow); outFile.newLine();
                                      }
                                    }
                              outFile.newLine();

                              outFile.close();

                            }
                          }

                          // Print out exceptions.
                          catch (IOException ioe) { System.out.println("I/O Exception in file writing: "+ioe); }
                        }
                      } catch (Exception ce) {
                               System.err.println(ce.getMessage());
                      }
                      if (filename != null)
                        ((GUI)parent).statusTextField.setText("The DB file has been created and saved:  "+filename);
                      else ((GUI)parent).statusTextField.setText("");
        }


}