package musr.client.dbreader;
import java.io.*;

/**
 * This class is a LineReader that filters a File.
 * (String readLine() is extended from superclass BufferedReader)
 *
 * @author Ivan Tucakov,
 */
public class FileLineReader extends BufferedReader
		implements LineReader, java.io.Serializable {

  static final long serialVersionUID = 0L; // SUID

  String pattern;  // The string we are going to be matching.

  /**
   * Constructor
   * Passes the stream to our superclass
   */
  public FileLineReader(Reader in) { super(in); }


  /**
   * This is the filter: call our superclass's readLine() to get the
   * actual lines, but only return lines that contain the pattern.
   * When the superclass readLine() returns null (EOF), we return null.
   **/
  public String matchLine(String pattern) throws IOException {
    String line;
    do { line = super.readLine(); }
    while ((line != null) && line.indexOf(pattern) == -1);
    return line;
  }


}
