package musr.client.dbreader;
import java.io.*;

/**
 * This class is a LineReader that filters a URL.
 * It was supposed to be used by DBFileReader but I don't think it is needed so it can be erased
 *
 * @author Ivan Tucakov, Nikola Tucakov
 */
public class URLLineReader extends InputStreamReader
		implements LineReader {
  String pattern;  // The string we are going to be matching.

  /** Pass the stream to our superclass */
  public URLLineReader(InputStream  in) { super(in); }


  /**
   * This is the filter: call our readLine() to get the
   * actual lines, but only return lines that contain the pattern.
   * When the readLine() returns null (EOF), we return null.
   **/
  public String matchLine(String pattern) throws IOException {
		String line;
		do { line = readLine(); }
		while ((line != null) && line.indexOf(pattern) == -1);
		return line;
  }

 	public String readLine() {
		String line = new String("");
		char[] buffer = new char[1];
		int numchars = 1;
 		try {
			while (((numchars=super.read(buffer,0,1)) != -1) && (buffer[0] != '\n'))
				line += String.valueOf(buffer[0]);
		}
		catch (IOException e) { System.err.println(e.getMessage()); }
		if (numchars == -1) return null;
		else return line;
	}
}
