package musr.client.function;

/**
 * Represents a seperated component of some string imput. It can be anything that
 * is separated with space (or comma, period..) from the other tokens in the string
 *
 * @author Ari
 */

public class Token {
	// Instance Variables
	private String name;
	private TokenKind kind;

	// Constructor Methods
	public Token(String name, TokenKind kind) {
		this.name = new String(name);
		this.kind = new TokenKind(kind.getKind());
	}

	// Instance Methods

	/**
         *  Returns higher number for the 'kind' with higher precedence
         */
	public int getPrecedence() {
		if (kind.equals(TokenKind.openpar)) return 1;
		else if (kind.equals(TokenKind.add)) return 2;
		else if (kind.equals(TokenKind.subtract)) return 3;
		else if (kind.equals(TokenKind.multiply)) return 4;
		else if (kind.equals(TokenKind.divide)) return 5;
		else if (kind.equals(TokenKind.funcname)
				 || kind.equals(TokenKind.negate)
                                 || kind.equals(TokenKind.pozitive)) return 6;
		else if (kind.equals(TokenKind.power)) return 7;
		return -1;
// throw exeption - Token not an operator
	}


	public Double getValue() {
		// if (kind.equals(TokenKind.number))
		return Double.valueOf(name);
// else throw exception = kind not a number
	}
	public String getName() { return name; }
	public int getKind() { return kind.getKind(); }
}




