package musr.client.gui;
import musr.client.datacolumn.*;
import java.lang.*;  // for String()
import java.util.*;  // for Vector()
import javax.swing.*;

/**
 * This class holds a Vector of DataColumns, its title and abstract.
 * GUI Class uses it.
 *
 * @author Ivan Tucakov, Nikola Tucakov
 */
public class DataTable implements Cloneable, java.io.Serializable {

  static final long serialVersionUID = 0L; // SUID

              // DataTables instance Variables
              private String title = new String("null");
              private String abstr = new String("null"); // contains the abstract
              private String comment = new String("null");  // contains all comments
              private Vector columns = new Vector();    // Vetor of DataColumn-s
              public JTextArea tableHistory = new JTextArea();

              public String filepath = new String(""); // filepath (directorypath/filename) String for DataTable to know where this datatable was loaded from

              // Methods
              public final String getTitle() { return title; }
              public final String getComment() { return comment; }
              public final String getAbstract() { return abstr; }
              public final Vector getColumns() {return columns; }
              public final JTextArea getTableHistory() {return tableHistory; }

              public final void setTitle(String title) { this.title = title; }
              public final void setAbstract(String abstr) { this.abstr = abstr; }
              public final void setComment(String comment) { this.comment = comment; }

              /**
               * Returns the index associated with this name. If it doesn't exist, returns -1
               */
              public final int getIndex(String name) {
                  int index = -1;
                  for(int i=0;i<this.columnCount();i++)
                    if (name.equals(((DataColumn)this.columns.get(i)).getName())) { index = i; break; }
                  return index;
              }
              public final DataColumn getColumn(int index) { return ((DataColumn) columns.elementAt(index));	}
              public final void setColumn(DataColumn dataColumn, int index) { columns.setElementAt(dataColumn, index); }
              public final DataColumn getColumn(String name) {
                  for(int i=0;i<this.columnCount();i++)
                    if (name.equals(((DataColumn)this.columns.get(i)).getName()))
				return ((DataColumn) columns.elementAt(i));
                  return null; // in case it didn't return anything
               }
		public final void addColumn(DataColumn column) {
				columns.addElement(column); }
		public final void removeColumnAt(int index) {
				columns.removeElementAt(index);	}
		public final void removeAllColumns() { columns.removeAllElements(); }
		public final int columnCount() { return columns.size(); }

                /**
                 * Constructor
                 * pass a filepath (directorypath/filename) String for DataTable to know where this datatable was loaded from
                 */
                public DataTable(String filepath) {
                  this.filepath = filepath;
                }
                
                public DataTable()
                {
                    this.filepath = "";     //supposedly this will refer to "the empty abstract file" or something
                }

		/**
                 * with this overridden method the DataTable can be printed in a nice format
                 */
		public String toString() {
				String returnValue = "\nTITLE: \n" + title + "\n\n" +
						"COMMENT: \n" + comment + "\n" +
						"COLUMNS: " + "\n";
				for(int i=0; i<columns.size(); i++)
						returnValue += columns.elementAt(i);
				return returnValue;
		}


		public Object clone() throws CloneNotSupportedException {
				DataTable returnValue = (DataTable)super.clone();
				returnValue.columns = (Vector)columns.clone();
                                //note: need to clone the DataColumns within the Vector too!
                                for(int i=0; i<columns.size(); i++)
                                  returnValue.columns.add(i,((DataColumn)columns.get(i)).clone());
				String cloneFrom[] = new String[3];
				String cloneTo[] = new String[3];
                                cloneFrom[0] = abstr;
				cloneFrom[1] = comment;
				cloneFrom[2] = title;
				cloneTo = (String[])cloneFrom.clone();
                                returnValue.abstr = cloneTo[0];
				returnValue.comment = cloneTo[1];
				returnValue.title = cloneTo[2];
				return returnValue;
		}

}
