package musr.client.gui;
import java.util.*;

/**
 * This Class basically holds all the data tables that are loaded in the GUI Data Tables Window,
 *     where user can choose to select desired columns to plot
 *
 * This class operates with a HashTable(associative arrays) of
 * DataTables or anything else that you put in it
 * What the key of the element stored in Hashtable will be is defined
 * by the counter which grows each time a new element is added.
 * This way each element is associated with a different key.
 * The counter is Long because the key must be an Object,
 * but for removing, int is sent.
 * GUI Class uses this Class to store DataTables.
 *
 * @author Ivan Tucakov, Nikola Tucakov
 */
public class Dictionary implements Cloneable , java.io.Serializable {

  static final long serialVersionUID = 0L; // SUID

  // instance variables
  //private Hashtable dictionary = new Hashtable();
  private Vector dictionary;
  //private Long counter;

  // constructor
  public Dictionary() {
    dictionary = new Vector();
    //counter = new Long(0);
  }

  // instance methods
  public void addElement(Object obj) {
    //dictionary.put(counter, obj); incCounter();
    dictionary.add(obj);
  }
//  public void putElementFirst(Object obj) {dictionary.put(new Long(0), obj); }
  public Object getElement(int index) {
  return dictionary.get(index); }

  /** Removes the element at the given key, note: it reduces all the keys above that one by one */
  public void removeElement(int index) {
    dictionary.remove(index);
                                          /*     decCounter(); // this counter is for future adding of the key
                                               // The procedure is to copy all the values one level down starting at the one that we wnat to ERASE
                                               // and then when traversing is done, erase the 'top' key, since everything is in numerical order
                                               // Note that the Key will be calculated to remain the same relative to the index where it is, i.e. accending
                                                 for(int i=index; i<dictionary.size()-1; i++) { // the Key (and its Object) #size-1 will be erased
                                                   dictionary.put(new Long(i), dictionary.get(new Long(i+1)) );
                                                 }
                                               dictionary.remove(new Long(dictionary.size()-1)); // remove the last Object and it's key         */
    }

    public int size() { return dictionary.size(); }

    /**
    * Retruns the key of an Object that is located in the list at the given position
    * Hash table doesn't have a method like this. It might not be the best algorihtm
    * but there isn't an easier way...so far. Yes there is.. just send an Long(index) as the key and get the Object.. I'll leave it like this for now..
    */
    public int getKey(int listPosition) {
      return listPosition; /// This is completely dummy, I use it just because it is used everywhere in the GUI
/*      Enumeration keys = dictionary.keys();
      int returnValue = -1;
      // loop through all the elements in the dictionary and find the key
  System.out.println("-------v");
      for(int i=dictionary.size()-1; keys.hasMoreElements(); i--) {
        Object nextElement = keys.nextElement();
System.out.println("nextElement "+nextElement);
System.out.println("i "+i);
        if (i == listPosition) {
          returnValue = ((Long)nextElement).intValue();
          break;
        }
      }
 System.out.println("-------^");
      return returnValue;       */
    }

  //  public void incCounter() { counter = new Long(counter.intValue()+1); }
   // public void decCounter() { counter = new Long(counter.intValue()-1); }


   /**
   * with this overridden method the Dictionary can be printed in a nice format
   */
   public String toString() {
     String returnValue = "\nDICTIONARY: \n";
    //for(int i=0; i<dictionary.size(); i++)
    //returnValue += (DataTable) dictionary.elementAt(i);
    returnValue += dictionary;
    return returnValue;
   }
   public Object clone ()
   throws CloneNotSupportedException
   {
   Dictionary returnValue = (Dictionary)super.clone();
   returnValue.dictionary = (Vector)dictionary.clone();
   //note: need to clone the dataTables within the Hashtable too!
   for(int i=0; i<dictionary.size(); i++) {
     returnValue.dictionary.add(i,((DataTable)dictionary.get(i)).clone());
  }
  Long cloneFrom[] = new Long[1];
  Long cloneTo[] = new Long[1];
  //cloneFrom[0] = counter;
  cloneTo = (Long[])cloneFrom.clone();
  //returnValue.counter = cloneTo[0];

  return returnValue;
  }

}
