package musr.client.gui;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * Frame where all the graphs are plotted
 *
 * @author Ivan Tucakov, Nikola Tucakov
 */
public class PlotFrame extends Frame {

	private boolean autoGrid;

	public void setAutoGrid(boolean autoGrid) { this.autoGrid = autoGrid; }

 	// Constructor
	public PlotFrame() {
		super("Plotting Frame");
		this.setSize(1470,950); //width, height.
		autoGrid = true;

		// Arrange to detect window close events
		this.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				PlotFrame.this.dispose();
			}
		});

		// If auotGrid option is selected, the grid should be set whenever the
		// Frame is resized. Algorithm depending on the plot count should be written
		this.addComponentListener(new ComponentAdapter() {
		 	public void componentResized(ComponentEvent e) {
					if (autoGrid) {
							int plotCount = PlotFrame.this.getComponentCount();
							PlotFrame.this.setLayout(new GridLayout(2, 2, 10, 10));
					}
			}
		});
	}

 	// remove all the components in the PlotFrame
 	public void clearPlotFrame() {
		this.removeAll();
	}

	/*
		// Each time Frame is repainted, figure out the best grid fit
		public void repaint() {
		//		super.repaint();

		int plotCount = this.getComponentCount();
		//		this.setLayout(new GridLayout(0, 1, 10, 10));

		}
	*/

}
