package musr.client.gui;

/**
 * This class holds information about a certain plot
 * it is associated with every x-axis that is selected to be plotted in the GUI.
 *
 * @author Ivan Tucakov, Nikola Tucakov
 */
public class PlotRecord implements Cloneable, java.io.Serializable {
  static final long serialVersionUID = 0L; // SUID
		// instance Variables
                /**
                 *  position of the plot in layout Frame {1,2,3...}
                 *  This is old variable and is redundant
                 */
              public int layoutPosition;

                /**
                 * Every axis is from a DataTable that has a speciffic title. This value holds that
                 *   This variable is used when there are attempts to check which DataTable this x axis belongs to (e.g. RemoveDataTable() method in GUI)
                 */

                 public String title;

                /**
                 * whether to plot on x or y axis
                 */
              public boolean inverted;
                /**
                 * whether it's visible
                 */
              public boolean visible;

              // constructors
              public PlotRecord(boolean inverted, boolean visible, int layPos, String title) {
                this.inverted = inverted;
                this.visible = visible;
                this.layoutPosition = layPos;
                this.title = title;
              }
              public PlotRecord(int layoutPosition, String title) {
                this(false, true, layoutPosition, title);
              }

              // instace methods
              public final int getLayoutPosition() { return layoutPosition; }
              public final void setLayoutPosition(int pos) { this.layoutPosition = pos; }

              public final boolean isInverted() { return inverted; }
              public final boolean isVisible() { return visible; }
              public final void setInverted(boolean inverted) { this.inverted = inverted; }
              public final void setVisible(boolean visible) { this.visible = visible; }

              public Object clone() throws CloneNotSupportedException {
                  PlotRecord returnValue = (PlotRecord)super.clone();
                  returnValue.inverted = inverted;
                  returnValue.layoutPosition = layoutPosition;
                  returnValue.visible = visible;
                  return returnValue;
		}
}
