package musr.client.gui;
import java.awt.*;
import java.awt.List;
import java.util.*;
import musr.client.dbreader.*;

/**
 * This class contains all the necessary components to save a state of the GUI Frame.
 * The variable settings are adjusted to be the same as a GUI initial default setting.
 *
 * @author Ivan Tucakov, Nikola Tucakov
 */

 public class SaveGUI extends java.lang.Object implements java.io.Serializable {

  static final long serialVersionUID = 0L; // SUID


  /** This variable is used to treat parameters and constants as case-sensitive or case-insensitive */
  boolean caseOn = true; // make it case-sensitive by default
  /** These variables are used to calculate the size of the symbols in the graph. The calculation is size=nPix/m where nPix is the width of the plot in
   *  pixels and m = max(N,Nmax) where N is the number of points for the graph that is being plotted withiin this plot. */
  public long Nmax = 20; //just put some default values, they will change anyways
  public long nPix = 300;

   /**
    * this variable is used for file loading.
    */
    public String dirPath = "/";

  /** The Data Variables from the db file and any other constants are stored in this class
   *  the values in it will be loaded everytime a new DataTable is imported, overwriting any previous
   *  values from some other previous DataTables (if any)
   *  It is also possible to define the constant variables manually */
  Constants dataTableVariables = new Constants(); /* WILL BE SEIRALIZED */
  /** This is a collection of 'custom' functions
   * (For now) they only take one parameter and when defined, the parameter should be x.*/
  Functions functionsTable = new Functions(); /* WILL BE SEIRALIZED */

  /**
   * These are variables (directory paths and file names) that are used for RMI db file importing
   */
   // musr.triumf.ca variables
    TextField openFileTextField1 = new TextField("/home/itucakov/public_html/dbfiles/");
    TextField openFileTextField2 = new TextField("beauty.db");
    TextField openFileTextField3 = new TextField("/tmp/");
    TextField openFileTextField4 = new TextField("beauty.db");
    // cmms.triumf.ca variables
    TextField openCFileTextField1 = new TextField("/home/itucakov/public_html/dbfiles/");
    TextField openCFileTextField2 = new TextField("beauty.db");
    TextField openCFileTextField3 = new TextField("/tmp/");
    TextField openCFileTextField4 = new TextField("beauty.db");

  /* The Frames Window Components*/
  // Assign null for label since these Checkboxes will never be used in GUI, they just hold the value
  Checkbox gridAutoCheckbox = new Checkbox("auto",false);
  Checkbox gridManualCheckbox = new Checkbox("manual",true);
  Checkbox invertedCheckbox = new Checkbox("x <-> y", false);
  Checkbox visibleCheckbox = new Checkbox("visible", true);
  Choice gridXChoice = new Choice(); // more in saveGUI()
  Choice gridYChoice = new Choice(); // more in saveGUI()
  Choice layoutChoice = new Choice(); // more in saveGUI()

  /** Colection of (DataTable)-s or anything else
   * This is where all the imported DataTables/columns are stored */
  Dictionary dictionary = new Dictionary(); /* WILL BE SEIRALIZED */
  List dataTableList =  new List(10, false);
  //List columnList =  new List(10, false); // there is no need to save this List. It will be restored in the GUI with the method reloadColumnList();

  // These are user defined x and y axis data table columns
  Vector xAxisDataTable = new Vector(); // For each Frame there is a x-Axis DataTable of Columns created by the user to plot /* WILL BE SEIRALIZED */
  Vector titlexAxis = new Vector();      // The title of the xAxis (Vector of Strings) /* WILL BE SEIRALIZED */
  Vector namexAxis = new Vector();     // The name of the xAxis (Vector of Strings) /* WILL BE SEIRALIZED */
  Vector plotsRecord = new Vector();     // Plotting Records of columns in x-Axis List (PlotRecord-s) /* WILL BE SEIRALIZED */
  Vector yAxisDataTable = new Vector();  // for each x-Axis column there is a y-Axis DataTable of Columns created by the user to plot /* WILL BE SEIRALIZED */
  Vector titleyAxis = new Vector();      //    (Vector of Strings) /* WILL BE SEIRALIZED */
  //List xAxisList = new List(6, false); // there is no need to save this List. It will be restored in the GUI with the method reloadxAxisList();
  //List yAxisList = new List(6, false); // there is no need to save this List. It will be restored in the GUI with the method reloadyAxisList();

  /* The Plot Options */
  Vector plotsOptions = new Vector();    // Plotting Options, for each layout frame (PlotOptionsFrame) /* WILL BE SEIRALIZED */
		                                             // first one is added when layoutChoice is filled /* WILL BE SEIRALIZED */

  /** MUD Variables **/
   List runsList = new List();
   TextField histNumberTextField = new TextField(8);
  TextField firstBinTextField = new TextField(4);
  TextField lastBinTextField = new TextField(4);
  TextField packingTextField = new TextField(5);
  int firstLastChoiceIndex = 0;
  int packingChoiceIndex = 0;
  Vector bkgd1Text = new Vector();
  Vector bkgd2Text = new Vector();
  Vector overrideNT0 = new Vector();
  Vector overrideNT1 = new Vector();
  Vector overrideNT2 = new Vector();
  int spectrumChoiceIndex = 0;
  // Complex spectrum window
  Choice useSpectrum = new Choice();
  TextField RRFFreq = new TextField();
  TextField RRFPackBin = new TextField();
  Choice RRFMenu = new Choice();
  Vector phaseRRF = new Vector();


  /** There is a seperate plot for each created Frame, this is a Vector of Plot2D's  */
  //Vector plots = new Vector();

  public SaveGUI() {
  }
 }
