package musr.client.plot2d;
import musr.client.datacolumn.*;
import java.applet.*;
import java.awt.*;
import java.util.*;
import java.lang.*;
import java.lang.reflect.*;

/**
 * This class holds all the X and Y axis DataColumns in two vectors. It makes it easy
 * to approach any array value from a certain DataColumn or get any other information about
 * that  DataColumn.
 * Note: if Y axis gets plotted with x axis a few times, the LoadXY method will load the same X DataColumn over and over again!
 *
 * @author Ivan Tucakov, Nikola Tucakov
 */
public class Series implements java.io.Serializable {

  static final long serialVersionUID = 0L; // SUID
  /* Instance variables */
  public Vector dataX;
  public Vector dataY;

  /* Constructor methods */
	public Series() {
 		dataX = new Vector();
		dataY = new Vector();
	}

  /* Methods */

  // Load X and Y
  public void LoadXY(DataColumn dataX, DataColumn dataY) {
    try {
      if (dataX==null) this.dataX.addElement(null);
      else this.dataX.addElement((DataColumn)dataX);
      if (dataY==null) this.dataY.addElement(null);
      else this.dataY.addElement((DataColumn)dataY);
    }
    catch (Exception e) {System.err.println("Error: can't clone dataX or dataY");}
  }

  /** Method that accesses Instance Variables
     * Declare final not to get dynamic method lookup, and could be initialised by the compiler */
  public final DataColumn getDataX(int j) {
    if (dataX.elementAt(j)==null) return null;
    else return (DataColumn)dataX.elementAt(j);
  }
    /** Method that accesses Instance Variables
     * Declare final not to get dynamic method lookup, and could be initialised by the compiler */
    public final DataColumn getDataY(int j) {
      if (dataY.elementAt(j)==null) return null;
      else return (DataColumn)dataY.elementAt(j);
    }
    /** Method that accesses Instance Variables
     * Declare final not to get dynamic method lookup, and could be initialised by the compiler */
     public final double getValueX(int vect, int arr) {
       return Tools.objToDoub( ((DataColumn) dataX.elementAt(vect)).getValue(arr) );
      }
    /** Method that accesses Instance Variables
     * Declare final not to get dynamic method lookup, and could be initialised by the compiler */
     public final double getValueY(int vect, int arr) {
       return Tools.objToDoub( ((DataColumn) dataY.elementAt(vect)).getValue(arr) );
      }
    /** Method that accesses Instance Variables
     * Declare final not to get dynamic method lookup, and could be initialised by the compiler */
    public final String getTitleX(int vect) {
      return ((DataColumn) dataX.elementAt(vect)).getName();
    }
    /** Method that accesses Instance Variables
     * Declare final not to get dynamic method lookup, and could be initialised by the compiler */
     public final String getTitleY(int vect) {
       return ((DataColumn) dataY.elementAt(vect)).getName();
    }
    /** Method that accesses Instance Variables
     * Declare final not to get dynamic method lookup, and could be initialised by the compiler */
     public final String getUnitsX(int vect) {
       return ((DataColumn) dataX.elementAt(vect)).getUnits();
    }
    /** Method that accesses Instance Variables
     * Declare final not to get dynamic method lookup, and could be initialised by the compiler */
     public final String getUnitsY(int vect) {
       return ((DataColumn) dataY.elementAt(vect)).getUnits();
    }
    /** Method that accesses Instance Variables
     * Declare final not to get dynamic method lookup, and could be initialised by the compiler */
    public final String getLabelX(int vect) {
      return ((DataColumn) dataX.elementAt(vect)).getLabel();
    }
    /** Method that accesses Instance Variables
     * Declare final not to get dynamic method lookup, and could be initialised by the compiler */
     public final String getLabelY(int vect) {
       return ((DataColumn) dataY.elementAt(vect)).getLabel();
      }
    /** Method that accesses Instance Variables
     * Declare final not to get dynamic method lookup, and could be initialised by the compiler */
     public final int getSizeX(int vect) {
       return ((DataColumn) dataX.elementAt(vect)).getSize();
    }
    /** Method that accesses Instance Variables
     * Declare final not to get dynamic method lookup, and could be initialised by the compiler */
    public final int getSizeY(int vect) {
      return ((DataColumn) dataY.elementAt(vect)).getSize();
    }

}
