//: MuSR_HistHdr.java

package musr.spect;

public class MuSR_HistHdr implements java.io.Serializable {

  public int histNumber;    // Histogram number [instance number]
  public int histType;      // Histogram type [should be 0x02010002 hex]
  public int nBytes;        // number of bytes in this (packed?) Histogram
  public int nBins;         // number of bins in this Histogram
  public int bytesPerBin;   // bytes per bin [0 for "packed" data]
  public double nsPerBin;   // nanoseconds per bin
  public double t0_ns;      // left edge of bin 1 to t=0 [nanosec]
  public int t0_bin;        // bin number where t=0
  public int goodBin1;      // first bin of good t>0 data
  public int goodBin2;      // last bin of good t>0 data
  public int bkgd1;         // first bin of t<0 Background data
  public int bkgd2;         // last bin of t<0 Background data
  public int nEvents;       // total number of events in Histogram
  public String title;      // Histogram name [like "Left" or "Rig ht"]

  /* histogram header print method */
  public void print () {
    Format.print(System.out, "\ntype 0x%08x", histType);
    System.out.print(" Histogram #" +histNumber);
    System.out.print(":\t title \"" + title +"\"");
    System.out.print("\t nEvents= " +nEvents);
    System.out.print("\nnBins= " +nBins);
    System.out.print(", nsPerBin= " +nsPerBin);
    System.out.print("\t(t0_ns= " +t0_ns);
    System.out.print("; t0_bin= " +t0_bin +")");
    System.out.print("\n(goodBin1= " +goodBin1);
    System.out.print(", goodBin2= " +goodBin2 +")");
    System.out.print("\t(bkgd1= " +bkgd1);
    System.out.print(", bkgd2= " +bkgd2 +")\n");
  }

  /* histogram header prettyPrint method */
  public void prettyPrint () {
    System.out.print("\nHistogram #" +histNumber);
    System.out.print(" \"" +title +"\"");
    System.out.print("\t" +nEvents +" evts");
    System.out.print(" in " +nBins +" bins\n");
    if ( nsPerBin != 0.0 ) System.out.print(nsPerBin +" ns/bin; ");
    if ( t0_bin != 0 ) System.out.print("t=0 in bin " +t0_bin+" ");
    if ( t0_ns != 0.0 )
      System.out.print("[" +t0_ns +" ns past left edge of bin 1]\n");
    if ( bkgd1 != 0 ) System.out.print("t<0 background in bins " +bkgd1);
    if ( bkgd2 != 0 ) System.out.print(" to " +bkgd2+"; ");
    System.out.print("good data in bins " +goodBin1);
    System.out.print(" to " +goodBin2 +")\n");
  }

}
